import 'dart:io';

import 'package:path/path.dart';
import 'package:protobuf3_parser/protobuf3_parser.dart';
import 'package:protobuf3_parser/src/extensions.dart';

class DirectoryAssetReader extends AssetReader {
  Directory dir;
  DirectoryAssetReader(this.dir);

  @override
  bool canRead(AssetId assetId) =>
      join(dir.path, assetId.path).file.existsSync();

  @override
  Stream<List<int>> read(AssetId assetId) =>
      join(dir.path, assetId.path).file.openRead();
}
