import 'package:protobuf3_parser/protobuf3_parser.dart';

class Enum3 extends Element3 {
  List<EnumField> fields;
  Enum3(
    String name, {
    List<Comment> comments = const [],
    this.fields = const [],
  }) : super(name, comments);

  String toProtobufString([int indentLevel = 0]) {
    final indent = "\t" * indentLevel;
    final x = StringBuffer();

    for (final documentation in documentations) {
      x.writeln("$indent${documentation.actualText}");
    }
    x.writeln("${indent}enum $name {");

    for (final field in fields) {
      for (final fieldDocumentation in field.documentations) {
        x.writeln("$indent\t${fieldDocumentation.actualText}");
      }
      x.writeln("$indent\t${field.name} = ${field.id};");
    }

    x.writeln("$indent}");
    return x.toString();
  }

  @override
  String toString() => toProtobufString();
}
