import 'package:protobuf3_parser/protobuf3_parser.dart';
import 'package:protobuf3_parser/src/const.dart';

class MessageField {
  Element3 type;
  int? id;
  String name;
  bool isList;
  final List<Comment> comments;
  Message3? parent;
  MessageField(this.name, this.type,
      {this.id, this.comments = const [], this.isList = false, this.parent});

  Iterable<Comment> get documentations =>
      comments.where((e) => e.isDocumenation);

  bool get isCoreType {
    if (type is CoreTypeMessage) {
      return true;
    } else {
      return false;
    }
  }

  bool get isCoreString => isCoreType && type.name == CoreTypes.string;
  bool get isCoreInt64 => isCoreType && type.name == CoreTypes.int64;
  bool get isCoreInt32 => isCoreType && type.name == CoreTypes.int32;
  bool get isCoreBool => isCoreType && type.name == CoreTypes.bool;
  bool get isCoreBytes => isCoreType && type.name == CoreTypes.bytes;
  bool get isCoreDouble => isCoreType && type.name == CoreTypes.double;
  bool get isCoreFloat => isCoreType && type.name == CoreTypes.float;

  @override
  String toString() =>
      "${comments.isEmpty ? '' : "${comments.join("\n")}\n"}${isList ? 'repeated ' : ''}${type.name} $name = ${id ?? 1};";
}
