import 'package:protobuf3_parser/protobuf3_parser.dart';

class Service3 extends Element3 {
  List<ServiceMethod> methods;

  Service3(
    String name, {
    List<Comment> comments = const [],
    this.methods = const [],
  }) : super(name, comments);

  String toProtobufString([int indentLevel = 0]) {
    final indent = "\t" * indentLevel;

    final x = StringBuffer();
    for (final documentation in documentations) {
      x.writeln("$indent${documentation.actualText}");
    }
    x.writeln("${indent}service $name {");

    for (final method in methods) {
      for (final methodDocumentation in method.documentations) {
        x.writeln("$indent\t${methodDocumentation.actualText}");
      }
      x.writeln(method.toProtobufString(indentLevel + 1));
    }

    x.writeln("$indent}");
    return x.toString();
  }

  @override
  String toString() => toProtobufString();
}
