import 'package:protobuf3_parser/protobuf3_parser.dart';

class ServiceMethod {
  String name;
  final List<Comment> comments;
  final Message3 request;
  final Message3 response;
  final bool isStreamRequest;
  final bool isStreamResponse;

  ServiceMethod(this.name, this.request, this.response,
      {this.comments = const [],
      this.isStreamRequest = false,
      this.isStreamResponse = false});

  Iterable<Comment> get documentations =>
      comments.where((e) => e.isDocumenation);

  String toProtobufString([int indentLevel = 0]) {
    final indent = "\t" * indentLevel;
    final x = StringBuffer();
    x.write("${indent}rpc $name (");
    if (isStreamRequest) x.write("stream ");
    x.write("${request.name}) returns (");
    if (isStreamResponse) x.write("stream ");
    x.write("${response.name});");
    return x.toString();
  }

  @override
  String toString() => toProtobufString();
}
